//+------------------------------------------------------------------+
//|                                           Daily PIVOT LEVELS.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
//#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_color4 Lime
//---- input parameters

//---- buffers

double S1Buffer[];
double R1Buffer[];
double S2Buffer[];
double R2Buffer[];
string Sup1="JS 1", Res1="JR 1";
string Sup2="JS 2", Res2="JR 2";
int fontsize=8;
double S1,R1,S2,R2;
double LastHigh,LastLow,x;

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

   ObjectDelete("JSup1");
   ObjectDelete("JRes1");
   ObjectDelete("JSup2");
   ObjectDelete("JRes2");
  

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;


//---- indicator line
   
   SetIndexStyle(0,DRAW_LINE,3,1,Red);
   SetIndexStyle(1,DRAW_LINE,3,1,Lime);
   SetIndexStyle(2,DRAW_LINE,3,1,Red);
   SetIndexStyle(3,DRAW_LINE,3,1,Lime);
   
   SetIndexBuffer(0,S1Buffer);
   SetIndexBuffer(1,R1Buffer);
   SetIndexBuffer(2,S2Buffer);
   SetIndexBuffer(3,R2Buffer);
   

//---- name for DataWindow and indicator subwindow label
   short_name="Jimmy Daily PIVOTS";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int    counted_bars=IndicatorCounted();

   int limit, i;
   double dif;
//---- indicator calculation
if (counted_bars==0)
{
   x=Period();
   if (x>240) return(-1);
   ObjectCreate("JSup1", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("JSup1", "       JS1",fontsize,"Arial",Red);
   SetIndexLabel(1, "JS1");
   ObjectCreate("JRes1", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("JRes1", "       JR1",fontsize,"Arial",Lime);
   SetIndexLabel(2, "JR1");
   ObjectCreate("JSup2", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("JSup2", "       JS2",fontsize,"Arial",Red);
   SetIndexLabel(3, "JS2");
   ObjectCreate("JRes2", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("JRes2", "       JR2",fontsize,"Arial",Lime);
   SetIndexLabel(4, "JR2");
}
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
//   if(counted_bars>0) counted_bars--;
   limit=(Bars-counted_bars)-1;

for (i=limit; i>=0;i--) {
if (TimeDayOfWeek(Time[i+1])!=0){ // Monday Fix

if (High[i+1]>LastHigh) LastHigh=High[i+1];
if (Low[i+1]<LastLow) LastLow=Low[i+1];

if (TimeDay(Time[i])!= TimeDay(Time[i+1]))
   {
   dif = Close[i+1] * 0.0035;
   R1 = Close[i+1] + dif ;
   S1 = Close[i+1] - dif ;

   dif = Close[i+1] * 0.0050;
   R2 = Close[i+1] + dif ;
   S2 = Close[i+1] - dif ;

   ObjectMove("JSup1", 0, Time[i],S1);
   ObjectMove("JRes1", 0, Time[i],R1);
   ObjectMove("JSup2", 0, Time[i],S2);
   ObjectMove("JRes2", 0, Time[i],R2);
   }
}   
    S1Buffer[i]=S1;
    R1Buffer[i]=R1;
    S2Buffer[i]=S2;
    R2Buffer[i]=R2;
}

//----
   return(0);
  }
//+------------------------------------------------------------------+


