//+------------------------------------------------------------------+
//| PS_Darvas_Box_5_1.mq4
//+------------------------------------------------------------------+
//---- indicator settings
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red      
#property indicator_color2 Blue

//---- buffers
double TopBoxBuffer[];
double BottomBoxBuffer[];

extern int Periods = 3;	

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(2);
     
   SetIndexBuffer(0,TopBoxBuffer);
   SetIndexBuffer(1,BottomBoxBuffer);
      
   SetIndexDrawBegin(0,10);
   SetIndexDrawBegin(1,10);
   
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);

   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS) + 2);   
   IndicatorShortName("PS_Darvas_Box_5(" + Periods + ")");

   return(0);
}

double hhv(int period, int ref)
{
   double hhvValue = -2147483648;
    
   for (int i = ref; i <= ref + period -1; i++)
   {
      if (hhvValue < High[i])
         hhvValue = High[i];
   }   
   
   return(hhvValue);
}

double llv(int period, int ref)
{
   double llvValue = 2147483647;
    
   for (int i = ref; i <= ref + period -1; i++)
   {
      if (llvValue > Low[i])
         llvValue = Low[i];
   }   
   
   return(llvValue);
}

int start()
{   

   for (int i = Bars - 1; i >= 0; i--)
   {
      if (High[i + 3] >= hhv(Periods, i + 4) && High[i + 2] < High[i + 3] &&
         High[i + 1] < High[i + 3] && High[i] < High[i + 3])
         TopBoxBuffer[i] = High[i + 3];
      else
         TopBoxBuffer[i] = TopBoxBuffer[i + 1]; 

      if (High[i + 3] >= hhv(Periods, i + 4) && High[i + 2] < High[i + 3] &&
         High[i + 1] < High[i + 3] && High[i] < High[i + 3])
         BottomBoxBuffer[i] = llv(4, i);
      else
         BottomBoxBuffer[i] = BottomBoxBuffer[i + 1]; 
   }

   return(0);
}

